#include "sound_int.h"
#include "sound.h"
#include "gym/gym.h"
#include "zlib.h"
#include "unzip.h"
#include <pspaudio.h>
#include "pspcommon.h"

CODEC_GYM::input_gym *gymCodec = NULL;

#define MAX_BUFFER_LENGTH 16384
#define MAX_BUFFER_LENGTH_MASK 16383
const int buffPerFrame = 1024;
char menuSoundTitle[128], menuSoundAlbum[128], menuSoundArtist[128];
int menuSoundBoxActive = 0;

char menu_zipfilename[MAX_PATH];
int menu_musiclen = 0, menu_lastNumber;
void *menu_musicdata = NULL;
int musicEnabled = 0;
volatile int musicThread = -1;
int musicThreadFrequency;
//Si vaut 1, quitter
int musicThreadEnd = 0, musicRequestNewSong = 0;
u32 snd_buffer[MAX_BUFFER_LENGTH], tmp_buffer[2][buffPerFrame];
s64 buffer1 = 0, buffer2 = 0;
int bufferValue;
u32 lastSample;
//Numro de fichier / nombre d'lments dans la playlist
int menu_filenumber, menu_playlistcount;
//-1 = disabled, 0 = stopped, 1 = playing, 2 = paused
int musicState = -1;
int musicVolume = 0x8000, musicChannelVolume = 0;
int isVgmInited = 0, songType = -1;
enum {SONG_VGM, SONG_GYM};
CFILE *currentSongFile = NULL;

void VGM_Init();
int VGM_play(char *fn, CFILE *r, SONGINFO * info, unsigned int flags);
int VGM_DecodeThread(short *SampleBuffer, int length, int *finallen);
void VGM_SetFrequency(int frequency);
u32 ramAvailable (void);

void FillBufferArbitrary(int frame)		{
	int i;
	int val = bufferValue;
	u32 sample = lastSample;
	for (i=0;i<buffPerFrame;i++)		{
		val += musicThreadFrequency;
		if (val >= 44100)		{
			sample = snd_buffer[buffer1 & MAX_BUFFER_LENGTH_MASK];
			buffer1++;
			val -= 44100;
		}
		tmp_buffer[frame][i] = sample;
	}
	bufferValue = val;
	lastSample = sample;
}

void FillBuffer44100(int frame)		{
	int i;
	for (i=0;i<buffPerFrame;i++)		{
		tmp_buffer[frame][i] = snd_buffer[buffer1 & MAX_BUFFER_LENGTH_MASK];
		buffer1++;
	}
}

int gymThread(SceSize u1, void *u2) {
	int channel = sceAudioChReserve(-1, 1024, 0);
	int size, bps, nch, srate;
	int sourcePerFrame = -1;
	int frame = 1, success;
	bufferValue = 0;
	for (;!musicThreadEnd;) {
		u32 *buffer, bufferReal[1024];
		int i /*, no*/, success;
//		no = 0;
		success = 1;
		while (buffer1 + buffPerFrame > buffer2 /*&& no < 3*/)		{
			if (songType == SONG_GYM)		{
				if (!gymCodec->get_samples_pcm((void**)&buffer, &sourcePerFrame, &srate, &bps, &nch))			{
					musicRequestNewSong = 1;
					goto end;
				}
				sourcePerFrame >>= 2;
			}
			else if (songType == SONG_VGM)		{
				buffer = bufferReal;
				if (VGM_DecodeThread((short*)buffer, 1024 >> 2, &sourcePerFrame))
					success = 0;
//				sourcePerFrame = 1024;
			}
			for (i=0;i<sourcePerFrame;i++)		{
				snd_buffer[buffer2 & MAX_BUFFER_LENGTH_MASK] = buffer[i];
				buffer2++;
			}
//			no++;
		}
		//Trop de retard
		if (buffer1 + buffPerFrame > buffer2)
			buffer1 = buffer2 - buffPerFrame;
		frame = 1 - frame;
		if (musicThreadFrequency == 44100)
			FillBuffer44100(frame);
		else
			FillBufferArbitrary(frame);
		if (musicChannelVolume < musicVolume)
			musicChannelVolume = musicChannelVolume * 3 / 2 + 2;
		if (musicChannelVolume > musicVolume)
			musicChannelVolume = musicVolume;
		sceAudioOutputPannedBlocking(channel, musicChannelVolume, musicChannelVolume, (char*)tmp_buffer[frame]);
		//C'tait la dernire sample
		if (!success)			{
			musicRequestNewSong = 1;
			goto end;
		}
	}
end:
	sceAudioChRelease(channel);
	musicThread = 0;
	sceKernelExitDeleteThread(0);
}

/*int menuPlaySound()		{
	CFILE file;
	SONGINFO song;
	if (musicThread >= 0 && !musicThreadEnd)		{
		musicThreadEnd = 1;
		sceKernelWaitThreadEnd(musicThread, NULL);
		if (gymCodec)		{
			delete gymCodec;
			gymCodec = NULL;
		}
	}
	musicThread = sceKernelCreateThread("Music thread", (SceKernelThreadEntry)gymThread, 0x8, 256*1024, 0, 0 );
	if (musicThread >= 0)			{
		if (file.open("test.gym", "rb"))			{
			song.set_filename("test.gym");
			if (!gymCodec)
				gymCodec = new CODEC_GYM::input_gym;
			if (gymCodec->open(&file, &song, 0))		{
				musicThreadEnd = 0;
				sceKernelStartThread(musicThread, 0, 0 );
				return 1;
			}
		}
	}
	return 0;
}*/

int menuPlaySoundEx(CFILE *f)		{
	SONGINFO song;
	if (musicThread >= 0 /*&& !musicThreadEnd*/)		{
		musicThreadEnd = 1;
		sceKernelWaitThreadEnd(musicThread, NULL);
//		sceKernelDeleteThread(musicThread);
	}
	if (gymCodec)		{
		delete gymCodec;
		gymCodec = NULL;
	}
	musicThreadEnd = 0;
	musicThread = sceKernelCreateThread("Music thread", (SceKernelThreadEntry)gymThread, 0x8, 256*1024, 0, 0 );
	if (musicThread >= 0)			{
		if (f)			{
			int filetype;
			char *extension = strstr(f->name, ".");
			if (!extension)
				extension = "";
			
			//Tags par dfaut
			strcpy(menuSoundTitle, "[Title unknown]");
			strcpy(menuSoundAlbum, "[Artist unknown]");

			//Type GYM (Genesis YM2612)
			if (!strcmp(extension, ".gym"))			{
				song.set_filename("test.gym");
				if (!gymCodec)
					gymCodec = new CODEC_GYM::input_gym;
				musicThreadFrequency = menuConfig.music.frequency;
				gymCodec->set_frequency(menuConfig.music.frequency);
				if (gymCodec->open(f, &song, 0))		{
					songType = SONG_GYM;
					sceKernelStartThread(musicThread, 0, 0 );
					return 1;
				}
			}
			//Type VGM (Video Game Music) ou VGZ (VGM g-zipp)
			else if (!strcmp(extension, ".vgm"))			{
				song.set_filename("test.vgm");
				if (!isVgmInited)
					VGM_Init();
				musicThreadFrequency = menuConfig.music.frequency;
				VGM_SetFrequency(menuConfig.music.frequency);
				if (!VGM_play(NULL, f, &song, 0))		{
//					u32 buffer[1024];
//					VGM_DecodeThread((short*)buffer, 1024 >> 2);
					songType = SONG_VGM;
					sceKernelStartThread(musicThread, 0, 0 );
					return 1;
				}
			}
		}
	}
	return 0;
}

int menuPlayZipSound(char *filename, int number)				{
	unzFile zip_file;
	unz_file_info unzinfo;
	char nom[256];
	int l;

	zip_file = 0;    
	zip_file = unzOpen(filename);
	if (zip_file) {
		unz_global_info pglobal_info;
		
		unzGetGlobalInfo(zip_file,&pglobal_info);
		menu_playlistcount = pglobal_info.number_entry;

		if (number == -1)			{
			struct timeval now;
			sceKernelLibcGettimeofday( &now, 0 );
			srand((now.tv_usec+now.tv_sec*1000000));
			do		{
				number = rand()%pglobal_info.number_entry;
			} while (menu_filenumber == number && pglobal_info.number_entry > 1);
			menu_filenumber = number;
		}

		unzGoToFirstFile(zip_file);
		while (number--) {
			unzGoToNextFile(zip_file);
		}
		if (unzGetCurrentFileInfo(zip_file, &unzinfo, nom, sizeof(nom), NULL, 0, NULL, 0) != UNZ_OK) {
			unzClose (zip_file);
			return 0;
		}

		//Librer les donnes qui existaient dj - ralis par le blockfree du currentSongFile
/*		if (menu_musicdata)		{
			free(menu_musicdata);
			menu_musiclen = 0;
		}*/

		unzOpenCurrentFile (zip_file);
		menu_musiclen = unzinfo.uncompressed_size;
		menu_musicdata = (void*)malloc(menu_musiclen);
		if (menu_musicdata)
			unzReadCurrentFile(zip_file,(void*)(menu_musicdata), menu_musiclen);
		unzCloseCurrentFile (zip_file);
		unzClose (zip_file);

		if (menu_musicdata)			{
			//On doit arrter la musique en cours  tout prix, sinon on risque d'avoir des plantages car la mmoire est libre
			menuMusicStop();

			if (!currentSongFile)
				currentSongFile = new CFILE;
			currentSongFile->set_name(nom);
			if (currentSongFile->open(menu_musicdata, menu_musiclen, "rb"))		{
				currentSongFile->blockfree = 1;
				if (menuPlaySoundEx(currentSongFile))		{
					musicEnabled = 1;
					musicState = 1;
					menuSoundBoxActive = MENU_SOUND_BOX_ACTIVE_MAX;
					return 1;
				}
			}
		}
	}
	return 0;
}

// *** FUNCTIONS ***
#define RAM_BLOCK      (1024 * 1024)

u32 ramAvailableLineareMax (void)
{
 u32 size, sizeblock;
 u8 *ram;


 // Init variables
 size = 0;
 sizeblock = RAM_BLOCK;

 // Check loop
 while (sizeblock)
 {
  // Increment size
  size += sizeblock;

  // Allocate ram
  ram = (u8*)malloc(size);

  // Check allocate
  if (!(ram))
  {
   // Restore old size
   size -= sizeblock;

   // Size block / 2
   sizeblock >>= 1;
  }
  else
   free(ram);
 }

 return size;
}

u32 ramAvailable (void)
{
 u8 **ram, **temp;
 u32 size, count, x;


 // Init variables
 ram = NULL;
 size = 0;
 count = 0;

 // Check loop
 for (;;)
 {
  // Check size entries
  if (!(count % 10))
  {
   // Allocate more entries if needed
   temp = (u8**)realloc(ram,sizeof(u8 *) * (count + 10));
   if (!(temp)) break;
 
   // Update entries and size (size contains also size of entries)
   ram = temp;
   size += (sizeof(u8 *) * 10);
  }

  // Find max lineare size available
  x = ramAvailableLineareMax();
  if (!(x)) break;

  // Allocate ram
  ram[count] = (u8*)malloc(x);
  if (!(ram[count])) break;

  // Update variables
  size += x;
  count++;
 }

 // Free ram
 if (ram)
 {
  for (x=0;x<count;x++) free(ram[x]);
  free(ram);
 }

 return size;
}

void menuStartSound(char *filename)		{
	if (menuConfig.music.repeatMode < 4)
		menu_filenumber = 0;
	else
		menu_filenumber = -1;
	menuPlayZipSound(filename, menu_filenumber);
	strcpy(menu_zipfilename, filename);
	musicRequestNewSong = 0;
	const int values[] =		{
		//Normal
		0x1000,
		//+1
		0x2000,
		//+2
		0x4000,
		//+3
		0x8000
	};
	musicChannelVolume = musicVolume = values[menuConfig.sound.volume];
}

void menuMusicNextTrack()		{
	int alreadyDone = 0;
	//Nouvelle musique requise
	switch (menuConfig.music.repeatMode)			{
		case 0:
		case 2:
			//Jusqu' ce qu'on trouve un bon fichier  charger...
			do			{
				menu_filenumber++;
				//Encore des fichiers?
				if (menu_filenumber >= menu_playlistcount)		{
					//Fin de la playlist?
					if (menuConfig.music.repeatMode == 0)			{
						musicEnabled = 0;
						break;
					}
					//On recommence
					else 			{
						//Eviter les boucles infinies
						if (alreadyDone)
							break;
						menu_filenumber = 0;
						alreadyDone = 1;
					}
				}
			} while (!menuPlayZipSound(menu_zipfilename, menu_filenumber));
			break;

		case 1:
			//On rpte le mme...
			menuPlayZipSound(menu_zipfilename, menu_filenumber);
			break;

		case 5:
			//On rpte le mme...
			menuPlayZipSound(menu_zipfilename, -1);
			break;
	}
}

void soundStandardVblank()		{
	if (musicEnabled)		{
		const int values[] =		{
			//Normal
			0x1000,
			//+1
			0x2000,
			//+2
			0x4000,
			//+3
			0x8000
		};
		musicVolume = values[menuConfig.sound.volume];
	}
	if (musicEnabled && musicRequestNewSong)		{
		musicRequestNewSong = 0;
		menuMusicNextTrack();
	}
}

void menuMusicPlay()			{
	//Nouveau fichier?
	if (!musicEnabled && menuConfig.music.filename[0])		{
		menuStartSound(menuConfig.music.filename);
	}
	if (musicEnabled && musicThread < 0)		{
		musicThreadEnd = 0;
		musicThread = sceKernelCreateThread("Music thread", (SceKernelThreadEntry)gymThread, 0x8, 256*1024, 0, 0 );
		sceKernelStartThread(musicThread, 0, 0 );
		musicState = 1;
	}
}

void menuMusicPause()			{
	if (musicEnabled && musicThread >= 0)		{
		musicThreadEnd = 1;
		sceKernelWaitThreadEnd(musicThread, NULL);
		musicThread = -1;
		musicState = 2;
		musicChannelVolume = 0x200;
	}
}

void menuMusicStop()			{
	if (musicEnabled && musicThread >= 0)		{
		musicThreadEnd = 1;
		sceKernelWaitThreadEnd(musicThread, NULL);
		musicThread = -1;
		musicState = 0;
	}
}
